/*
 *  exo03-05.h
 *  maxim des tableaux
 */

/*
 * renvoie le maximum d'un tableau non vide
 * name : maximum
 * @tab : le tableau
 * @taille : la taille du tableau, @taille > 0
 * @return : le maximum
 */
double maximum(double tab[], int taille) {
  double max = tab[0];
  unsigned int i;
  for (i = 1; i < taille; i++) {
    if (tab[i] > max) max = tab[i];
  }
  return max;
}

/*
 * renvoie le deuxième maximum d'un tableau non vide
 * name : second_max
 * @tab : le tableau
 * @taille : la taille du tableau, @taille > 0
 * @return : le deuxième maximum
 */
double second_max(double tab[], unsigned int taille) {
  double max = tab[0];
  double smax = tab[0];
  unsigned int i;
  for (i = 1; i < taille; i++) {
    if (tab[i] > smax) {
      if (tab[i] > max) {
        smax = max;
        max = tab[i];
      }
      else smax = tab[i];
    }
  }
  return smax;
}

/*
 * enregistre dans *max et *min les indexes du minimum et du maximum
 * du tableau
 * name : minmax
 * @tab : le tableau
 * @taille : la taille du tableau, @taille > 0
 * @max , @min : pointeurs à entiers
 */
void minmax(double tab[], unsigned int taille, unsigned int *max, unsigned int *min) {
  *max = 0;
  *min = 0;
  unsigned int i;
  for (i = 1; i < taille; i += 2) { // cycle sur les impairs
    if (tab[i-1] < tab[i]) {
      if (tab[i-1] < tab[*min]) *min = i-1;
      if (tab[i] > tab[*max]) *max = i;
    } else {
      if (tab[i] < tab[*min]) *min = i;
      if (tab[i-1] > tab[*max]) *max = i-1;
    }
  }
  if (taille%2) { // si la taille est impaire on fait de contrôles
                  // supplementaires sur la derniére valeur
    if (tab[taille-1] < tab[*min]) *min = taille-1;
    if (tab[taille-1] > tab[*max]) *max = taille-1;
  }
}
// attention: il y a une erreur dans le feuille original, 
// sur le type de la fonction
